#!/usr/local/bin/perl
# Scale some image down to the preview size

require './file-lib.pl';
&ReadParse();
use POSIX;
$p = $ENV{'PATH_INFO'};

# Try to guess type from filename
$type = &guess_mime_type($p, undef);
if (!$type) {
	# No idea .. use the 'file' command
	$out = &backquote_command("file ".
				  quotemeta(&resolve_links($p)), 1);
	if ($out =~ /text|script/) {
		$type = "text/plain";
		}
	else {
		&error_exit(&text('preview_etype', $p));
		}
	}

# Make sure the type is OK
if ($type ne "image/gif" && $type ne "image/jpeg" && $type ne "image/png") {
	&error_exit(&text('preview_etype2', $p));
	}

&switch_acl_uid_and_chroot();
if (!&can_access($p)) {
	# ACL rules prevent access to file
	&error_exit(&text('view_eaccess', $p));
	}

# Test if the file can be opened
if (!open(FILE, $p)) {
	# Unix permissions prevent access
	&error_exit(&text('view_eopen', $p, $!));
	}
close(FILE);

# Find an appropriate scaler
$pnmcmd = $type eq "image/gif" ? "giftopnm" :
	  $type eq "image/jpeg" ? "djpeg" :
	  $type eq "image/png" ? "pngtopnm" : undef;
&has_command($pnmcmd) ||
	&error_exit(&text('preview_ecmd', $pnmcmd));
&has_command("pnmscale") ||
	&error_exit(&text('preview_ecmd', "pnmscale"));
&has_command("cjpeg") ||
	&error_exit(&text('preview_ecmd', "cjpeg"));

# Run scaler
$width = $config{'width'} || $userconfig{'width'} || 300;
print "Content-type: image/jpeg\n";
print "\n";
open(SCALE, "$pnmcmd <".quotemeta($p)." | pnmscale --width $width | cjpeg |");
while(<SCALE>) {
	print;
	}
close(SCALE);

sub error_exit
{
print "Content-type: text/plain\n";
print "Content-length: ",length($_[0]),"\n\n";
print $_[0];
exit;
}

